import gdb
import re

class galois_printer:
    def __init__(self, val):
        self.val = val

    def to_string(self):
        return str(int(self.val['element']))

def lookup(val):
    type = val.type
    if type.code == gdb.TYPE_CODE_REF:
        type = type.target()

    type = type.unqualified().strip_typedefs()
    typename = type.tag
    if (typename == None):
        return None

    regex = re.compile('^netcodec::galois<.*>$')
    if regex.match(typename):
        return galois_printer(val)

    return None

gdb.pretty_printers.append(lookup)
