#ifndef FILE_OPTS_H
#define FILE_OPTS_H

namespace p2pvdn {
	struct file_opts {
		unsigned num_slices;
		unsigned packet_size;
		unsigned coeff_size;
		unsigned filesize;

		file_opts()
		{
		}

		file_opts(const socket &socket)
		{
			socket >> num_slices >> packet_size;
			socket >> coeff_size >> filesize;
		}

		unsigned chunk_size() const
		{
			return num_slices * packet_size;
		}

		unsigned num_chunks() const
		{
			return (filesize + chunk_size() - 1) / chunk_size();
		}

		unsigned header_size() const
		{
			return coeff_size * num_slices;
		}

		unsigned packet_elements() const
		{
			return (packet_size + coeff_size - 1) / coeff_size;
		}
	};

	inline const socket &operator<<(const socket &socket, const file_opts &file_opts)
	{
		socket << file_opts.num_slices << file_opts.packet_size;
		socket << file_opts.coeff_size << file_opts.filesize;

		return socket;
	}

	inline const socket &operator>>(const socket &socket, file_opts &file_opts)
	{
		socket >> file_opts.num_slices >> file_opts.packet_size;
		socket >> file_opts.coeff_size >> file_opts.filesize;
	}
}

#endif
